<template>
    <v-container class="white ma-0 pa-0">
        <v-row no-gutters align="center">
            <v-col>
                <v-parallax height="700" class="w3-grayscale" :src="require('../assets/register_left.jpg')">
                    <span class="display-3 ma-4">Sign Up</span>
                    <span class="overline mb-2">Already have account?</span>
                    <span><router-link to="/login">
                        <v-btn outlined dark width="100">Login</v-btn>
                    </router-link></span>
                </v-parallax>
            </v-col>
            <v-col>
                <v-container>
                    <response-alert v-bind:error="error"></response-alert>
                    <v-form ref="registerForm" lazy-validation class="pb-4">
                        <v-text-field label="Username" name="login" v-model="registerForm.name" prepend-icon="mdi-account-box"
                                      type="text" :rules="rule.username"/>
                        <v-text-field label="Email" name="login" v-model="registerForm.email" prepend-icon="fa fa-envelope"
                                      type="text" :rules="rule.email"/>
                        <v-select
                                :items="genderOption"
                                :rules="rule.birthday"
                                v-model="registerForm.gender"
                                prepend-icon="fa fa-venus-mars"
                                label="Gender"
                        ></v-select>
                        <v-menu
                                ref="dataPicker"
                                v-model="datePicker"
                                :close-on-content-click="false"
                                transition="scale-transition"
                                offset-y
                                min-width="290px"
                        >
                            <template v-slot:activator="{ on }">
                                <v-text-field
                                        v-model="registerForm.birthday"
                                        :rules="rule.birthday"
                                        label="Birthday Date"
                                        prepend-icon="fa fa-calendar-alt"
                                        readonly
                                        v-on="on"
                                ></v-text-field>
                            </template>
                            <v-date-picker
                                    ref="picker"
                                    v-model="registerForm.birthday"
                                    :max="new Date().toISOString().substr(0, 10)"
                                    min="1950-01-01"
                                    @change="updateBirthday"
                            ></v-date-picker>
                        </v-menu>
                        <v-text-field
                                v-model="registerForm.password"
                                prepend-icon="fa fa-key"
                                :append-icon="passwordShow ? 'mdi-eye' : 'mdi-eye-off'"
                                :rules="rule.password"
                                :type="passwordShow ? 'text' : 'password'"
                                label="Password"
                                @click:append="passwordShow = !passwordShow"
                        ></v-text-field>
                    </v-form>
                    <v-btn color="green lighten-2" block tile @click="registerUser" dark><span class="overline">Sign Up</span>
                    </v-btn>
                </v-container>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import ResponseAlert from "./ResponseAlert";

    export default {
        name: "RegisterForm",
        components: {ResponseAlert},
        data() {
            return {
                rule:{
                    username: [
                        v => !!v || 'Username is required',
                        v => (v && v.length > 2) || 'Name must be more than 2 characters',
                    ],
                    password: [
                        v => !!v || 'Password is required',
                        v => (v && v.length > 8) || 'Password must be more than 8 characters',
                    ],
                    email:[
                        v => !!v || 'Email is required',
                        v => /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail must be valid',
                    ],
                    gender:[
                        v => !!v || 'Gender is required',
                    ],
                    birthday:[
                        v => !!v || 'Birthday is required',
                    ]
                },
                registerForm: {
                    name: '',
                    email: '',
                    birthday: null,
                    password: '',
                    gender: '',
                },
                genderOption: ["Male","Female"],
                error: "",
                passwordShow: true,
                datePicker: false
            }
        },
        methods:{
            registerUser(){
                if(this.$refs.registerForm.validate()){
                    this.changeLoading()
                    this.$store.dispatch('register', this.registerForm).then(() => {
                        this.changeLoading()
                        this.$router.push({name: 'Home'})
                    }).catch(error => {
                        this.errorResponse(error.response.data.message)
                    }).finally(() => {
                        this.changeLoading()
                    })
                }
            },
            updateBirthday (date) {
                this.$refs.dataPicker.save(date)
            },
            changeLoading() {
                this.$emit('isLoading')
            },
            errorResponse(error) {
                this.error = error
            },
        }
    }
</script>

<style scoped>

</style>